<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;
use Spatie\Permission\Traits\HasRoles;

class User extends Authenticatable
{
    use HasFactory, Notifiable, HasApiTokens, HasRoles, SoftDeletes;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'nama',
        'username',
        'password',
        'kode_skpd',
        'induk_opd_id',
        'level_id',
        'kategori_opd_id',
        'alamat',
        'unit_kerja_id',
        'nip'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    // public function role(){
    //     return $this->belongsTo(Role::class);
    // }

    public function PengelolaProgram(){
        return $this->hasMany(PengelolaProgram::class);
    }

    public function daerah(){
        return $this->belongsTo(UptDaerah::class,'daerah_id');
    }
     public function IndukOpd(){
        return $this->belongsTo(IndukOpd::class);
    }
     public function unit_kerja(){
        return $this->belongsTo(UnitKerja::class);
    }
}
